diff --git a/django/db/models/query.py b/django/db/models/query.py
index fedb61ed5d..7c934a6271 100644
--- a/django/db/models/query.py
+++ b/django/db/models/query.py
@@ -4,7 +4,6 @@ The main QuerySet implementation. This provides the public API for the ORM.
 
 import copy
 import operator
-import sys
 import warnings
 from contextlib import nullcontext
 from functools import reduce
@@ -35,6 +34,7 @@ from django.db.models.utils import (
     create_namedtuple_class,
     resolve_callables,
 )
+from django.native._loader import AVAILABLE as _NATIVE_AVAILABLE
 from django.utils import timezone
 from django.utils.deprecation import RemovedInDjango70Warning
 from django.utils.functional import cached_property
@@ -47,13 +47,39 @@ REPR_OUTPUT_SIZE = 20
 
 PROHIBITED_FILTER_KWARGS = frozenset(["_connector", "_negated"])
 
-# Tier 1+: process-local SQL templates for simple SELECT/UPDATE fast paths.
-# Keys vary by shape (eq/all/in/upd); values are interned SQL strings.
-# Write-once per key after first use (reduces post-fork COW churn).
+# SQL templates used by the model-save fast path in django.db.models.base.
+# QuerySet terminal shapes use the generation-aware native cache instead.
 _SIMPLE_SQL_CACHE = {}
 _FAST_PATH_MISS = object()
 
 
+def _q_from_native_tree(node):
+    """Rebuild an equivalent Django Q object from a C++ QueryPlan node."""
+    kind = node["kind"]
+    if kind == "atom":
+        values = node.get("values", ())
+        key = node["key"]
+        if key.rsplit(LOOKUP_SEP, 1)[-1] == "in":
+            value = list(values)
+        elif len(values) == 1:
+            value = values[0]
+        else:
+            value = list(values)
+        return Q((key, value))
+
+    children = [_q_from_native_tree(child) for child in node.get("children", ())]
+    if kind == "not":
+        if len(children) != 1:
+            raise ValueError("native NOT plan must have exactly one child")
+        return ~children[0]
+    connector = Q.AND
+    if kind == "or":
+        connector = Q.OR
+    elif kind == "xor":
+        connector = Q.XOR
+    return Q(*children, _connector=connector)
+
+
 class BaseIterable:
     def __init__(
         self, queryset, chunked_fetch=False, chunk_size=GET_ITERATOR_CHUNK_SIZE
@@ -294,7 +320,15 @@ class QuerySet(AltersData):
         self.model = model
         self._db = using
         self._hints = hints or {}
-        self._query = query or sql.Query(self.model)
+        # Native-supported chains don't need Django's mutable Query graph.
+        # Leave it unallocated until introspection or a fallback operation
+        # actually needs it. The pure-Python configuration remains eager.
+        if query is not None:
+            self._query = query
+        elif _NATIVE_AVAILABLE:
+            self._query = None
+        else:
+            self._query = sql.Query(self.model)
         self._result_cache = None
         self._sticky_filter = False
         self._for_write = False
@@ -308,21 +342,33 @@ class QuerySet(AltersData):
         # C++ ORM data-plane handle (optional). Poisoned via _native_disabled.
         self._native_qs = None
         self._native_disabled = False
+        # Supported native chains keep C++ as the authoritative query graph.
+        # QueryPlan owns replay strings and values without retaining Python
+        # dicts, tuples, Q objects, or Field objects.
+        self._native_authoritative = False
+        self._native_plan = None
 
     @property
     def query(self):
+        if self._native_authoritative:
+            self._native_materialize_python_query()
+        if self._query is None:
+            self._query = sql.Query(self.model)
         if self._deferred_filter:
             negate, args, kwargs = self._deferred_filter
             self._filter_or_exclude_inplace(negate, args, kwargs)
-            self._native_track_filter(negate, args, kwargs)
+            self._native_disabled = True
+            self._native_qs = None
             self._deferred_filter = None
         return self._query
 
     @query.setter
     def query(self, value):
-        if value.values_select:
+        if value is not None and value.values_select:
             self._iterable_class = ValuesIterable
         self._query = value
+        self._native_authoritative = False
+        self._native_plan = None
 
     def as_manager(cls):
         # Address the circular dependency between `Queryset` and `Manager`.
@@ -345,6 +391,9 @@ class QuerySet(AltersData):
         for k, v in self.__dict__.items():
             if k == "_result_cache":
                 obj.__dict__[k] = None
+            elif k in {"_native_plan", "_native_qs"}:
+                # Both native wrappers use functional copy-on-write updates.
+                obj.__dict__[k] = v
             else:
                 obj.__dict__[k] = copy.deepcopy(v, memo)
         return obj
@@ -352,6 +401,10 @@ class QuerySet(AltersData):
     def __getstate__(self):
         # Force the cache to be fully populated.
         self._fetch_all()
+        # Nanobind wrappers aren't part of Django's pickle contract. Replay
+        # the compact plan once and pickle the equivalent Python Query.
+        if self._native_authoritative:
+            self.query
         return {**self.__dict__, DJANGO_VERSION_PICKLE_KEY: django.__version__}
 
     def __setstate__(self, state):
@@ -694,36 +747,48 @@ class QuerySet(AltersData):
         return await sync_to_async(self.aggregate)(*args, **kwargs)
 
     def _native_terminal_update(self, kwargs):
-        handle = self._native_handle_for_sql()
-        if handle is None or not kwargs:
+        if not kwargs:
             return _FAST_PATH_MISS
-        try:
-            from django.native import orm as native_orm
+        connection = connections[self.db]
+        for name, value in kwargs.items():
+            if LOOKUP_SEP in name or hasattr(value, "resolve_expression"):
+                return _FAST_PATH_MISS
+        if self._native_qs is None and self._native_authoritative:
+            try:
+                from django.native import orm as native_orm
 
-            connection = connections[self.db]
-            qs = handle.clone()
-            for name, value in kwargs.items():
-                if LOOKUP_SEP in name or hasattr(value, "resolve_expression"):
-                    return _FAST_PATH_MISS
-                try:
-                    field = self.model._meta.get_field(name)
-                    prep = field.get_db_prep_save(value, connection)
-                except Exception:
-                    return _FAST_PATH_MISS
-                if not qs.add_update(name, prep):
-                    return _FAST_PATH_MISS
-            sql, params = qs.compile_sql()
-            if not sql:
+                compiled = native_orm.compile_query_plan_update(
+                    self.model,
+                    connection,
+                    self._native_plan,
+                    updates=kwargs,
+                )
+            except Exception:
+                return _FAST_PATH_MISS
+        else:
+            handle = self._native_handle_for_sql()
+            if handle is None:
                 return _FAST_PATH_MISS
-            with transaction.mark_for_rollback_on_error(using=self.db):
-                with connection.cursor() as cursor:
-                    cursor.execute(sql, params)
-                    rowcount = cursor.rowcount
-            if rowcount is None or rowcount < 0:
+            try:
+                compiled = handle.compile_update_kwargs(
+                    kwargs, native_orm._parameter_types_for_connection(connection)
+                )
+            except Exception:
                 return _FAST_PATH_MISS
-            return rowcount
-        except Exception:
+        if compiled is None:
+            return _FAST_PATH_MISS
+        sql, params = compiled
+        if not sql:
+            return _FAST_PATH_MISS
+        # Once execution starts, propagate database errors. Retrying the stock
+        # compiler after an error can leave the surrounding transaction broken.
+        with transaction.mark_for_rollback_on_error(using=self.db):
+            with connection.cursor() as cursor:
+                cursor.execute(sql, params)
+                rowcount = cursor.rowcount
+        if rowcount is None or rowcount < 0:
             return _FAST_PATH_MISS
+        return rowcount
 
     def _native_terminal_aggregate(self, kwargs):
         """
@@ -764,12 +829,12 @@ class QuerySet(AltersData):
                         field_name = name
                     else:
                         return _FAST_PATH_MISS
-                if not qs.annotate_aggregate(
-                    alias, func, field_name, distinct, star
-                ):
+                if not qs.annotate_aggregate(alias, func, field_name, distinct, star):
                     return _FAST_PATH_MISS
                 aliases.append(alias)
-            sql, params = qs.compile_sql()
+            sql, params = qs.compile_sql(
+                native_orm._parameter_types_for_connection(connection)
+            )
             if not sql:
                 return _FAST_PATH_MISS
             row = native_orm.execute_fetchall(connection, sql, params)
@@ -809,10 +874,15 @@ class QuerySet(AltersData):
         Perform the query and return a single object matching the given
         keyword arguments.
         """
-        if self.query.combinator and (args or kwargs):
+        if self._deferred_filter:
+            # Related-manager core filters must be part of eligibility checks
+            # and cannot be skipped by a native terminal.
+            self.query
+        combinator = self._query.combinator if self._query is not None else None
+        if combinator and (args or kwargs):
             raise NotSupportedError(
                 "Calling QuerySet.get(...) with filters after %s() is not "
-                "supported." % self.query.combinator
+                "supported." % combinator
             )
         # Tier 1+ fast paths: simple values_list/model get without full compiler.
         if not args and kwargs:
@@ -862,6 +932,9 @@ class QuerySet(AltersData):
             from django.native import orm as native_orm
 
             connection = connections[self.db]
+            handle = handle.clone()
+            if not handle.set_ordering([]):
+                return _FAST_PATH_MISS
             result = native_orm.materialize_models(
                 self.model, connection, handle, limit=MAX_GET_RESULTS
             )
@@ -911,9 +984,10 @@ class QuerySet(AltersData):
 
             connection = connections[self.db]
             h = handle.clone()
-            if self.query.is_sliced:
-                low = self.query.low_mark or 0
-                high = self.query.high_mark
+            query = self._query
+            if query is not None and query.is_sliced:
+                low = query.low_mark or 0
+                high = query.high_mark
                 if high is not None:
                     h.set_limit(int(high - low))
                 if low:
@@ -932,16 +1006,27 @@ class QuerySet(AltersData):
 
     def _simple_base_eligible(self, *, require_empty_where=True):
         """Shared guards for simple single-table SELECT fast paths."""
-        query = self.query
+        if self._native_authoritative and not self._native_has_only_projection():
+            return False
+        if self.model._meta.parents or self.model._meta.ordering:
+            return False
+        query = self._query
+        if query is None:
+            return True
         if (
             query.combinator
             or query.is_sliced
+            or query.is_empty()
             or query.distinct
             or query.distinct_fields
             or query.select_for_update
+            or query.select_related
             or query.group_by
             or query.annotations
             or query.extra
+            or query.extra_order_by
+            or query.deferred_loading != (frozenset(), True)
+            or query._filtered_relations
             or len(query.alias_map) > 1
         ):
             return False
@@ -960,8 +1045,15 @@ class QuerySet(AltersData):
 
     def _resolve_select_columns(self, field_names):
         """Return list of DB column names or None if any field is ineligible."""
+        fields = self._resolve_select_fields(field_names)
+        if fields is None:
+            return None
+        return [field.column for field in fields]
+
+    def _resolve_select_fields(self, field_names):
+        """Return concrete fields for a simple projection, or None."""
         opts = self.model._meta
-        cols = []
+        resolved = []
         for name in field_names:
             if not isinstance(name, str) or LOOKUP_SEP in name:
                 return None
@@ -971,8 +1063,8 @@ class QuerySet(AltersData):
                 return None
             if not getattr(f, "concrete", False) or not f.column:
                 return None
-            cols.append(f.column)
-        return cols
+            resolved.append(f)
+        return tuple(resolved)
 
     def _concrete_field_ok(self, field):
         if field is None:
@@ -983,18 +1075,6 @@ class QuerySet(AltersData):
             return False
         return bool(field.column)
 
-    def _cached_simple_sql(self, cache_key, builder):
-        sql = _SIMPLE_SQL_CACHE.get(cache_key)
-        if sql is not None:
-            return sql
-        sql = builder()
-        try:
-            sql = sys.intern(sql)
-        except TypeError:
-            pass
-        # setdefault: first writer wins; avoids duplicate dict entries under race.
-        return _SIMPLE_SQL_CACHE.setdefault(cache_key, sql)
-
     def _fast_path_simple_get(self, kwargs):
         """
         Fast path for::
@@ -1004,37 +1084,39 @@ class QuerySet(AltersData):
 
         when the queryset has no prior filters/joins/annotations.
         """
-        if len(kwargs) != 1 or not self._simple_base_eligible():
+        simple_projection = (
+            self._native_authoritative
+            and self._native_qs is None
+            and self._native_has_only_projection()
+        )
+        if len(kwargs) != 1 or (
+            not simple_projection and not self._simple_base_eligible()
+        ):
             return _FAST_PATH_MISS
         lookup_name, value = next(iter(kwargs.items()))
         if not isinstance(lookup_name, str) or LOOKUP_SEP in lookup_name:
             return _FAST_PATH_MISS
-        lookup_field = self._resolve_lookup_field(lookup_name)
-        if not self._concrete_field_ok(lookup_field):
-            return _FAST_PATH_MISS
 
         # --- values_list / values tuple path ---
         if self._fields is not None and self._iterable_class in (
             ValuesListIterable,
             FlatValuesListIterable,
         ):
-            select_columns = self._resolve_select_columns(self._fields)
-            if not select_columns:
+            if not self._fields:
                 return _FAST_PATH_MISS
             return self._execute_simple_eq_get(
-                select_columns, lookup_field, value, as_model=False
+                self._fields, lookup_name, value, as_model=False
             )
 
         # --- model instance path ---
         if self._fields is None and issubclass(self._iterable_class, ModelIterable):
             opts = self.model._meta
-            select_columns = [f.column for f in opts.concrete_fields if f.column]
             field_names = [f.attname for f in opts.concrete_fields if f.column]
-            if not select_columns:
+            if not field_names:
                 return _FAST_PATH_MISS
             return self._execute_simple_eq_get(
-                select_columns,
-                lookup_field,
+                field_names,
+                lookup_name,
                 value,
                 as_model=True,
                 model_field_names=field_names,
@@ -1042,48 +1124,24 @@ class QuerySet(AltersData):
         return _FAST_PATH_MISS
 
     def _execute_simple_eq_get(
-        self, select_columns, lookup_field, value, *, as_model, model_field_names=None
+        self, field_names, lookup_name, value, *, as_model, model_field_names=None
     ):
         db = self.db
         connection = connections[db]
         limit = MAX_GET_RESULTS
-        try:
-            param = lookup_field.get_db_prep_value(value, connection, prepared=False)
-        except Exception:
-            return _FAST_PATH_MISS
-
-        lookup_key = (
-            "pk"
-            if getattr(lookup_field, "primary_key", False)
-            else lookup_field.attname
-        )
-        field_names = (
-            list(self._fields)
-            if self._fields is not None
-            else list(model_field_names or [])
-        )
-
         sql = None
-        params = (param,)
+        params = ()
         try:
             from django.native import orm as native_orm
 
-            if field_names:
-                compiled = native_orm.compile_values_list_get(
-                    self.model,
-                    field_names=field_names,
-                    lookup_field=lookup_key,
-                    lookup_value=param,
-                    limit=limit,
-                    connection=connection,
-                )
-            else:
-                compiled = native_orm.compile_select(
-                    self.model,
-                    connection,
-                    kwargs={lookup_key: param},
-                    limit=limit,
-                )
+            compiled = native_orm.compile_values_list_get(
+                self.model,
+                field_names=field_names,
+                lookup_field=lookup_name,
+                lookup_value=value,
+                limit=limit,
+                connection=connection,
+            )
             if compiled is not None:
                 sql, param_list = compiled
                 params = tuple(param_list)
@@ -1116,6 +1174,20 @@ class QuerySet(AltersData):
             return row[0]
         return row
 
+    def _native_compile_deferred_simple_values(self, connection):
+        if (
+            self._native_plan is None
+            or self._native_qs is not None
+            or not self._native_authoritative
+            or self._fields is None
+        ):
+            return None
+        from django.native import orm as native_orm
+
+        return native_orm.compile_query_plan_values(
+            self.model, connection, self._native_plan
+        )
+
     def _fast_path_simple_values_fetch(self):
         """
         Fast path for values()/values_list() via C++ data plane.
@@ -1131,7 +1203,9 @@ class QuerySet(AltersData):
             FlatValuesListIterable,
         ):
             return _FAST_PATH_MISS
-        if not self._resolve_select_columns(self._fields):
+        if not self._native_authoritative and not self._resolve_select_columns(
+            self._fields
+        ):
             return _FAST_PATH_MISS
 
         db = self.db
@@ -1139,33 +1213,38 @@ class QuerySet(AltersData):
         try:
             from django.native import orm as native_orm
 
-            handle = self._native_handle_for_sql()
-            if handle is not None:
-                qs = handle.clone()
-                flat = self._iterable_class is FlatValuesListIterable
-                if not qs.values_list(list(self._fields), flat):
-                    return _FAST_PATH_MISS
-                if self.query.is_sliced:
-                    # Respect high/low marks when set.
-                    low = self.query.low_mark or 0
-                    high = self.query.high_mark
-                    if high is not None:
-                        qs.set_limit(int(high - low))
-                    if low:
-                        qs.set_offset(int(low))
-                sql, params = qs.compile_sql()
-            elif self._simple_base_eligible():
-                compiled = native_orm.compile_select(
-                    self.model,
-                    connection,
-                    field_names=list(self._fields),
-                    kwargs=None,
-                )
-                if compiled is None:
-                    return _FAST_PATH_MISS
+            compiled = self._native_compile_deferred_simple_values(connection)
+            if compiled is not None:
                 sql, params = compiled
             else:
-                return _FAST_PATH_MISS
+                handle = self._native_handle_for_sql()
+                if handle is not None:
+                    qs = handle
+                    query = self._query
+                    if query is not None and query.is_sliced:
+                        # Respect high/low marks when set.
+                        qs = handle.clone()
+                        low = query.low_mark or 0
+                        high = query.high_mark
+                        if high is not None:
+                            qs.set_limit(int(high - low))
+                        if low:
+                            qs.set_offset(int(low))
+                    sql, params = qs.compile_sql(
+                        native_orm._parameter_types_for_connection(connection)
+                    )
+                elif self._simple_base_eligible():
+                    compiled = native_orm.compile_select(
+                        self.model,
+                        connection,
+                        field_names=list(self._fields),
+                        kwargs=None,
+                    )
+                    if compiled is None:
+                        return _FAST_PATH_MISS
+                    sql, params = compiled
+                else:
+                    return _FAST_PATH_MISS
             if not sql:
                 return _FAST_PATH_MISS
             rows = native_orm.execute_fetchall(connection, sql, params)
@@ -1288,11 +1367,7 @@ class QuerySet(AltersData):
                 lookup_field.get_db_prep_value(v, connection, prepared=False)
                 for v in id_list
             ]
-            key = (
-                "pk"
-                if lookup_field.primary_key
-                else lookup_field.attname
-            ) + "__in"
+            key = ("pk" if lookup_field.primary_key else lookup_field.attname) + "__in"
             from django.native import orm as native_orm
 
             compiled = native_orm.compile_select(
@@ -1701,7 +1776,9 @@ class QuerySet(AltersData):
                 len(objs),
             )
         else:
-            batch_size = min(batch_size, max_batch_size) if batch_size else max_batch_size
+            batch_size = (
+                min(batch_size, max_batch_size) if batch_size else max_batch_size
+            )
         requires_casting = connection.features.requires_casted_case_in_updates
         if _native.AVAILABLE:
             batches = (
@@ -1709,7 +1786,9 @@ class QuerySet(AltersData):
                 for start, end in _native.in_bulk_batch_ranges(len(objs), batch_size)
             )
         else:
-            batches = (objs[i : i + batch_size] for i in range(0, len(objs), batch_size))
+            batches = (
+                objs[i : i + batch_size] for i in range(0, len(objs), batch_size)
+            )
         updates = []
         for batch_objs in batches:
             update_kwargs = {}
@@ -2180,34 +2259,22 @@ class QuerySet(AltersData):
         Update all elements in the current QuerySet, setting all the given
         fields to the appropriate values.
         """
-        from django import native as _native
-
-        if _native.AVAILABLE:
-            code = _native.queryset_write_guard(
-                bool(self.query.combinator),
-                self.query.is_sliced,
-                False,
-                False,
-            )
-            if code == 1:
-                self._not_support_combined_queries("update")
-            elif code == 2:
-                raise TypeError("Cannot update a query once a slice has been taken.")
-        else:
+        query_state = self._query
+        if query_state is not None and query_state.combinator:
             self._not_support_combined_queries("update")
-            if self.query.is_sliced:
-                raise TypeError("Cannot update a query once a slice has been taken.")
+        if query_state is not None and query_state.is_sliced:
+            raise TypeError("Cannot update a query once a slice has been taken.")
         self._for_write = True
-        # Single-row exact-lookup UPDATE without SQLCompiler when eligible.
-        fast = self._fast_path_simple_filter_update(kwargs)
-        if fast is not _FAST_PATH_MISS:
-            self._result_cache = None
-            return fast
-        # Live native handle (filter/exclude wired) → full UPDATE compile.
+        # An authoritative native filter compiles all assignments in one hop.
         native_upd = self._native_terminal_update(kwargs)
         if native_upd is not _FAST_PATH_MISS:
             self._result_cache = None
             return native_upd
+        # Legacy mirrored single-row exact-lookup fast path.
+        fast = self._fast_path_simple_filter_update(kwargs)
+        if fast is not _FAST_PATH_MISS:
+            self._result_cache = None
+            return fast
         query = self.query.chain(sql.UpdateQuery)
         query.add_update_values(kwargs)
 
@@ -2276,9 +2343,7 @@ class QuerySet(AltersData):
         if self._result_cache is None:
             return self.query.has_results(using=self.db)
         if _native.AVAILABLE:
-            return _native.queryset_exists_from_cache(
-                True, bool(self._result_cache)
-            )
+            return _native.queryset_exists_from_cache(True, bool(self._result_cache))
         return bool(self._result_cache)
 
     async def aexists(self):
@@ -2381,13 +2446,62 @@ class QuerySet(AltersData):
         clone.query.set_values(fields)
         return clone
 
+    def _native_simple_values_projection(self, fields, iterable_class):
+        """Keep a concrete-field projection in the authoritative native plan."""
+        from django import native as _native
+
+        if (
+            not _native.AVAILABLE
+            or not fields
+            or not all(isinstance(field, str) for field in fields)
+            or len(set(fields)) != len(fields)
+        ):
+            return None
+        if not self._native_authoritative and not self._simple_base_eligible():
+            return None
+
+        clone = self._chain()
+        plan = clone._native_plan_candidate("values", fields)
+        if plan is None:
+            return None
+        clone._native_store_plan(plan)
+        clone._fields = tuple(fields)
+        handle = clone._native_qs
+        if handle is not None:
+            try:
+                if iterable_class is ValuesIterable:
+                    projected = handle.with_values(list(fields))
+                else:
+                    projected = handle.with_values_list(
+                        list(fields), iterable_class is FlatValuesListIterable
+                    )
+            except Exception:
+                projected = None
+            if projected is None:
+                clone._native_materialize_python_query()
+                clone._native_disabled = True
+                clone._native_qs = None
+                clone.query.set_values(fields)
+                clone._iterable_class = iterable_class
+                return clone
+            clone._native_qs = projected
+
+        clone._iterable_class = iterable_class
+        return clone
+
     def values(self, *fields, **expressions):
+        if not expressions and fields:
+            native = self._native_simple_values_projection(fields, ValuesIterable)
+            if native is not None:
+                return native
         fields += tuple(expressions)
         clone = self._values(*fields, **expressions)
         clone._iterable_class = ValuesIterable
         return clone
 
     def values_list(self, *fields, flat=False, named=False):
+        from django import native as _native
+
         # Keep validation in pure Python (native hop was net-negative on hot paths).
         if flat and named:
             raise TypeError("'flat' and 'named' can't be used together.")
@@ -2399,6 +2513,12 @@ class QuerySet(AltersData):
         if flat and not fields:
             fields = [self.model._meta.concrete_fields[0].attname]
 
+        if not named and fields and all(isinstance(field, str) for field in fields):
+            iterable_class = FlatValuesListIterable if flat else ValuesListIterable
+            native = self._native_simple_values_projection(fields, iterable_class)
+            if native is not None:
+                return native
+
         field_names = {f: False for f in fields if not hasattr(f, "resolve_expression")}
         _fields = []
         expressions = {}
@@ -2429,7 +2549,9 @@ class QuerySet(AltersData):
                     if suffix.isdigit():
                         counter = int(suffix) + 1
                 else:
-                    while (field_name := f"{field_name_prefix}{counter}") in field_names:
+                    while (
+                        field_name := f"{field_name_prefix}{counter}"
+                    ) in field_names:
                         counter += 1
             if expression is not None:
                 expressions[field_name] = expression
